Index: QuantLibAddin/gensrc/metadata/functions/leg.xml
===================================================================
--- QuantLibAddin/gensrc/metadata/functions/leg.xml	(revision 16482)
+++ QuantLibAddin/gensrc/metadata/functions/leg.xml	(working copy)
@@ -1074,6 +1074,130 @@
       </ReturnValue>
     </Member>
 
+    <Member name='qlInterestRateCompoundFactor' type='QuantLib::InterestRate' superType='libraryClass'>
+      <description>Returns the compound factor between two dates based on the given InterestRate object.</description>
+      <libraryFunction>compoundFactor</libraryFunction>
+      <SupportedPlatforms>
+        <!--SupportedPlatform name='Excel' calcInWizard='false'/-->
+        <SupportedPlatform name='Excel'/>
+        <!--SupportedPlatform name='Cpp'/-->
+      </SupportedPlatforms>
+      <ParameterList>
+          <Parameters>
+            <Parameter name='StartDate' default='QuantLib::Date()'>
+              <type>QuantLib::Date</type>
+              <tensorRank>scalar</tensorRank>
+              <description>start date: start date for compound factor calculation.</description>
+            </Parameter>
+            <Parameter name='EndDate' default='QuantLib::Date()'>
+              <type>QuantLib::Date</type>
+              <tensorRank>scalar</tensorRank>
+              <description>end date: end date for compound factor calculation.</description>
+            </Parameter>
+            <Parameter name='RefPeriodStart' default='QuantLib::Date()'>
+              <type>QuantLib::Date</type>
+              <tensorRank>scalar</tensorRank>
+              <description>ref period start date: only needed for few daycounters (ex. Actual/Actual).</description>
+            </Parameter>
+            <Parameter name='RefPeriodEnd' default='QuantLib::Date()'>
+              <type>QuantLib::Date</type>
+              <tensorRank>scalar</tensorRank>
+              <description>ref period end date: only needed for few daycounters (ex. Actual/Actual).</description>
+            </Parameter>
+          </Parameters>
+      </ParameterList>
+      <ReturnValue>
+        <type>QuantLib::Real</type>
+        <tensorRank>scalar</tensorRank>
+      </ReturnValue>
+    </Member>
+
+    <Member name='qlInterestRateDiscountFactor' type='QuantLib::InterestRate' superType='libraryClass'>
+      <description>Returns the discount factor between two dates based on the given InterestRate object.</description>
+      <libraryFunction>discountFactor</libraryFunction>
+      <SupportedPlatforms>
+        <!--SupportedPlatform name='Excel' calcInWizard='false'/-->
+        <SupportedPlatform name='Excel'/>
+        <!--SupportedPlatform name='Cpp'/-->
+      </SupportedPlatforms>
+      <ParameterList>
+        <Parameters>
+          <Parameter name='StartDate' default='QuantLib::Date()'>
+            <type>QuantLib::Date</type>
+            <tensorRank>scalar</tensorRank>
+            <description>start date: start date for compound factor calculation.</description>
+          </Parameter>
+          <Parameter name='EndDate' default='QuantLib::Date()'>
+            <type>QuantLib::Date</type>
+            <tensorRank>scalar</tensorRank>
+            <description>end date: end date for compound factor calculation.</description>
+          </Parameter>
+          <Parameter name='RefPeriodStart' default='QuantLib::Date()'>
+            <type>QuantLib::Date</type>
+            <tensorRank>scalar</tensorRank>
+            <description>ref period start date: only needed for few daycounters (ex. Actual/Actual).</description>
+          </Parameter>
+          <Parameter name='RefPeriodEnd' default='QuantLib::Date()'>
+            <type>QuantLib::Date</type>
+            <tensorRank>scalar</tensorRank>
+            <description>ref period end date: only needed for few daycounters (ex. Actual/Actual).</description>
+          </Parameter>
+        </Parameters>
+      </ParameterList>
+      <ReturnValue>
+        <type>QuantLib::Real</type>
+        <tensorRank>scalar</tensorRank>
+      </ReturnValue>
+    </Member>
+
+    <Procedure name='qlInterestRateImpliedRate'>
+      <description>Returns the implied rate between two dates based on the given a compound factor.</description>
+      <alias>QuantLib::InterestRate::impliedRate</alias>
+      <SupportedPlatforms>
+        <!--SupportedPlatform name='Excel' calcInWizard='false'/-->
+        <SupportedPlatform name='Excel'/>
+        <!--SupportedPlatform name='Cpp'/-->
+      </SupportedPlatforms>
+      <ParameterList>
+        <Parameters>
+          <Parameter name='Compound' default='1.'>
+            <type>QuantLib::Real</type>
+            <tensorRank>scalar</tensorRank>
+            <description>compound: compound factor used to extract the rate.</description>
+          </Parameter>
+          <Parameter name='StartDate' default='QuantLib::Date()'>
+            <type>QuantLib::Date</type>
+            <tensorRank>scalar</tensorRank>
+            <description>start date: start date of rate calculation.</description>
+          </Parameter>
+          <Parameter name='EndDate' default='QuantLib::Date()'>
+            <type>QuantLib::Date</type>
+            <tensorRank>scalar</tensorRank>
+            <description>end date: end date of rate calculation.</description>
+          </Parameter>
+          <Parameter name='DayCounter' default='"Actual/365 (Fixed)"'>
+            <type>QuantLib::DayCounter</type>
+            <tensorRank>scalar</tensorRank>
+            <description>rate DayCounter ID.</description>
+          </Parameter>
+          <Parameter name='Compounding' default='"Continuous"' const='False'>
+            <type>QuantLib::Compounding</type>
+            <tensorRank>scalar</tensorRank>
+            <description>interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}).</description>
+          </Parameter>
+          <Parameter name='Frequency' default='"Annual"' const='False'>
+            <type>QuantLib::Frequency</type>
+            <tensorRank>scalar</tensorRank>
+            <description>frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly).</description>
+          </Parameter>
+        </Parameters>
+      </ParameterList>
+      <ReturnValue>
+        <type>QuantLib::Real</type>
+        <tensorRank>scalar</tensorRank>
+      </ReturnValue>
+    </Procedure>
+
     <Constructor name='qlInterestRate'>
       <libraryFunction>InterestRate</libraryFunction>
       <SupportedPlatforms>